;
; PedroM - Operating System for Ti-89/Ti-92+/V200.
; Copyright (C) 2003, 2005 Patrick Pelissier
;
; This program is free software ; you can redistribute it and/or modify it under the
; terms of the GNU General Public License as published by the Free Software Foundation;
; either version 2 of the License, or (at your option) any later version. 
; 
; This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
; See the GNU General Public License for more details. 
; 
; You should have received a copy of the GNU General Public License along with this program;
; if not, write to the 
; Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA 

; Exported PedroM library

PedroMLibKernel:
	dc.l	$4E754E75		; Header
	dc.l	'68kL'			; Signature
	dc.b	0,2			; InternalFormat, RelocCount
	dc.w	0,0,0			; Offset to main, comment, exit
	dc.b	1,32+2+1		; VersionNumber,Flags
	dc.w	0,0,PedoMLibExportTable-PedroMLibKernel,0	; Handle,Bss,Export,RamTable
PedoMLibExportTable:
	dc.w	(PedoMLibExportTableEnd-PedoMLibExportTable-2)/2
	dc.w	RamDataTable-PedroMLibKernel		; 0
	dc.w	RunMainFunction-PedroMLibKernel		; 1
	dc.w	HeapRealloc_redirect-PedroMLibKernel	; 2
	dc.w	HeapMax_redirect-PedroMLibKernel	; 3
	dc.w	printf_redirect-PedroMLibKernel			; 4
	dc.w	vcbprintf-PedroMLibKernel		; 5
	dc.w	clrscr_redirect-PedroMLibKernel			; 6
	dc.w	fclose-PedroMLibKernel			; 7
	dc.w	freopen-PedroMLibKernel			; 8
	dc.w	fopen-PedroMLibKernel			; 9
	dc.w	fseek-PedroMLibKernel			; A
	dc.w	ftell-PedroMLibKernel			; B
	dc.w	feof-PedroMLibKernel			; C
	dc.w	fputc-PedroMLibKernel			; D
	dc.w	fputs-PedroMLibKernel			; E
	dc.w	fwrite-PedroMLibKernel			; F
	dc.w	fgetc-PedroMLibKernel			; 10
	dc.w	fread-PedroMLibKernel			; 11
	dc.w	fgets-PedroMLibKernel			; 12
	dc.w	ungetc-PedroMLibKernel			; 13
	dc.w	fflush-PedroMLibKernel			; 14
	dc.w	clearerr-PedroMLibKernel		; 15
	dc.w	ferror-PedroMLibKernel			; 16
	dc.w	rewind-PedroMLibKernel			; 17
	dc.w	fprintf-PedroMLibKernel			; 18
	dc.w	tmpnam-PedroMLibKernel			; 19
	dc.w	DIALOG.Do-PedroMLibKernel		; 1A
	dc.w	qsort-PedroMLibKernel			; 1B
	dc.w	PID_Switch-PedroMLibKernel		; 1C
	dc.w	_tt_Decompress-PedroMLibKernel		; 1D
	dc.w	bsearch-PedroMLibKernel			; 1E
	dc.w	unlink-PedroMLibKernel			; 1F
	dc.w	rename-PedroMLibKernel			; 20
	dc.w	atoi-PedroMLibKernel			; 21
	dc.w	kbd_queue-PedroMLibKernel		; 22
	dc.w	rand-PedroMLibKernel			; 23
	dc.w	srand-PedroMLibKernel			; 24
	dc.w	calloc-PedroMLibKernel			; 25
	dc.w	realloc-PedroMLibKernel			; 26
	dc.w	atof-PedroMLibKernel			; 27
	dc.w	_sputc-PedroMLibKernel			; 28
	dc.w	perror-PedroMLibKernel			; 29
	dc.w	getenv_redirect-PedroMLibKernel		; 2A
	dc.w	system_redirect-PedroMLibKernel		; 2b
	dc.w	setvbuf-PedroMLibKernel			; 2c
	dc.w	kernel::exit-PedroMLibKernel		; 2d
	dc.w	kernel::atexit-PedroMLibKernel		; 2e
	
PedoMLibExportTableEnd:

	;;  Redirect reference (for short form)
HeapRealloc_redirect	bra	HeapRealloc
HeapMax_redirect	bra	HeapMax
getenv_redirect		bra	getenv
HeapAlloc_redirect	bra	HeapAlloc
HeapAllocPtr_redirect	bra	HeapAllocPtr
HeapDeref_redirect	bra	HeapDeref
HeapFree_redirect	bra	HeapFree
HeapLock_redirect	bra	HeapLock
HeapUnlock_redirect	bra	HeapUnlock
HeapGetLock_redirect	bra	HeapGetLock
HLock_redirect		bra	HLock
sprintf_redirect	bra	sprintf
Float2Int_redirect	bra	Float2Int
system_redirect		bra	system
ERD_dialog_redirect	bra	ERD_dialog
DrawStr_redirect	bra	DrawStr
InitGraphSystem_redirect	bra	InitGraphSystem
printf_redirect		bra	printf
clrscr_redirect		bra	clrscr
SymFindPtr_redirect	bra	SymFindPtr
KernelExec_redirect	bra	kernel::exec
strlen_reg_redirect	bra	strlen_reg
			
RamDataTable:
	dc.l	stdin
	dc.l	stdout
	dc.l	stderr
	dc.l	ARGC
	dc.l	ARGV
	dc.l	errno

; In: a0-> main function to call.
RunMainFunction:
	jmp	(a0)					; The Kernel (sld) does all the job.

PedroMLibraryEntry:
	;; Library Entry is:
	;;  LIBRARY.name   8 bytes
	;;  LIBRARY.org    4 bytes
	;;  LIBRARY.code   4 bytes 
	;;  LIBRARY.data   4 bytes
	;;  LIBRARY.refcnt 2 bytes
	;;  LIBRARY.relocf 2 bytes 
	dc.b	"pedrom",0,0
	dc.l	PedroMLibKernel
	dc.l	PedroMLibKernel
	dc.l	0
	dc.w	2
	dc.b	1,1
	
	ifd	GPL
_tt_Decompress:	
	rts
	endif
